---
title: PerformanceNavigationTiming
slug: Web/API/PerformanceNavigationTiming
tags:
  - API
  - Interface
  - Navigation Timing API
  - Performance Timeline API
  - Reference
  - Web Performance
---
<p>{{APIRef("Navigation Timing")}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The <strong><code>PerformanceNavigationTiming</code></strong> interface provides methods and properties to store and retrieve metrics regarding the browser's document navigation events. For example, this interface can be used to determine how much time it takes to load or unload a document.</span></p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<p>This interface extends the following {{domxref('PerformanceEntry')}} properties for navigation performance entry types by qualifying and constraining them as follows:</p>

<dl>
 <dt>{{domxref("PerformanceEntry.entryType")}} {{readonlyInline}}</dt>
 <dd>Returns <code>"navigation"</code>.</dd>
 <dt>{{domxref("PerformanceEntry.name")}} {{readonlyInline}}</dt>
 <dd>Returns the <a href="https://dom.spec.whatwg.org/#concept-document-url">document's address</a>.</dd>
 <dt>{{domxref("PerformanceEntry.startTime")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMHighResTimeStamp")}} with a value of "<code>0</code>".</dd>
 <dt>{{domxref("PerformanceEntry.duration")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMHighResTimeStamp","timestamp")}} that is the difference between the {{domxref("PerformanceNavigationTiming.loadEventEnd")}} and {{domxref("PerformanceEntry.startTime")}} properties.</dd>
</dl>

<p>This interface also extends following {{domxref('PerformanceResourceTiming')}} properties for navigation performance entry types by qualifying and constraining them as follows:</p>

<dl>
 <dt>{{domxref('PerformanceResourceTiming.initiatorType')}}{{readonlyInline}}</dt>
 <dd>Returns <code>"navigation"</code>.</dd>
</dl>

<p>The interface also supports the following properties:</p>

<dl>
 <dt>{{domxref('PerformanceNavigationTiming.domComplete')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing a time value equal to the time immediately before the browser sets the current document readiness of the current document to <em><a href="https://html.spec.whatwg.org/multipage/syntax.html#the-end">complete</a></em>.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.domContentLoadedEventEnd')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time value equal to the time immediately after the current document's <a href="https://html.spec.whatwg.org/multipage/syntax.html#the-end">DOMContentLoaded</a> event completes.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.domContentLoadedEventStart')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time value equal to the time immediately before the user agent fires the <a href="https://html.spec.whatwg.org/multipage/syntax.html#the-end">DOMContentLoaded</a> event at the current document.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.domInteractive')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing a {{domxref("DOMHighResTimeStamp","timestamp")}} representing the time value equal to the time immediately before the user agent sets the current document readiness of the current document to <a href="https://html.spec.whatwg.org/multipage/syntax.html#the-end">interactive</a>.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.loadEventEnd')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time when the load event of the current document is completed.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.loadEventStart')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time value equal to the time immediately before the load event of the current document is fired.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.redirectCount')}} {{readonlyInline}}</dt>
 <dd>A number representing the number of redirects since the last non-redirect navigation under the current browsing context.</dd>
 <dd>If there was no redirect, or if the redirect was from another origin, and that origin does not permit it's timing information to be exposed to the current origin then the value will be 0.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.requestStart')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time immediately before the user agent starts requesting the resource from the server, or from relevant application caches or from local resources.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.responseStart')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time immediately after the user agent's HTTP parser receives the first byte of the response from relevant application caches, or from local resources or from the server.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.type')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMString","string")}} representing the navigation type. Must be: "<code>navigate</code>", "<code>reload</code>", "<code>back_forward</code>" or "<code>prerender</code>".</dd>
 <dt>{{domxref('PerformanceNavigationTiming.unloadEventEnd')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time value equal to the time immediately after the user agent finishes the unload event of the previous document.</dd>
 <dt>{{domxref('PerformanceNavigationTiming.unloadEventStart')}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the time value equal to the time immediately before the user agent starts the unload event of the previous document.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("PerformanceNavigationTiming.toJSON()")}}</dt>
 <dd>Returns a {{domxref("DOMString")}} that is the JSON representation of the {{domxref("PerformanceNavigationTiming")}} object.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Navigation Timing Level 2', '#sec-PerformanceNavigationTiming', 'PerformanceNavigationTiming')}}</td>
   <td>{{Spec2('Navigation Timing Level 2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PerformanceNavigationTiming")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Performance.navigation")}}</li>
 <li>{{domxref("PerformanceNavigation")}}</li>
</ul>
